# see https://github.com/CanCanCommunity/cancancan/wiki/Defining-Abilities
class Ability
  include CanCan::Ability
  # builds the in-memory authorization item structure for the user
  def initialize(user)
    begin
      return unless user
      if user.super_admin?
        AuthItem.where(user_type: user.person.class, is_su_item: true).each do |item|
          item.apply(self, user, user.person.class)
        end
      else
        user.auth_items.each do |item|
          item.apply(self, user, user.person.class)
        end
      end
    rescue ActiveRecord::SubclassNotFound
      self.class.sync_auth_item_database
    end
  end



  # builds the authorization items structure in database
  #
  # this should be called anytime when new AuthItem classes are added or existing ones are changed regarding their
  # - models
  # - user_types
  # - actions
  def self.sync_auth_item_database
    AuthItem.sync_all
  end
end
