class JsonapiController < JSONAPI::ResourceController
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :null_session
  rescue_from ActiveRecord::RecordNotUnique  do |e|
    message = "#{e.message}" # make read and bold
    Rails.logger.info(message)
  end

  before_action do
    if Rails.env.development?
      authorized = true
    else
      authorized = request.headers.key?('HTTP_X_VSB_API_KEY') && request.headers['HTTP_X_VSB_API_KEY'] == Rails.configuration.x.local_env["VSB_API_KEY"]
    end
    head(403) unless authorized
    authorized
  end
end
