class ClientGroupGrid < BaseGrid

  scope do
    ClientGroup.all
  end


  filter(:name, :string) do |value|
    self.where(["name ILIKE ?",  "%#{value}%"])
  end
  filter(:semester_id, :enum, header: "Schuljahr",
     :select => proc { Semester.all.map {|c| [c.name, c.id] }}
  )

  column(:name, header: "Name")
  column(:description, header: "Beschreibung")
  column(:teacher, header: "Lehrer", :html => true) do |client_group|
    show_teacher(client_group.teacher)
  end
  column(:semester, header: "Schuljahr", :html => true) do |client_group|
    show_semester_name(client_group.semester)
  end
  column(:clients_total, header: "Schüleranzahl")
  column(:actions,  header: '', style: 'width:100px', :html => true) do |i|
    if can?(:update,i)
      update_button="<a href='#{edit_client_group_path(i)}' role='button' class='btn btn-success btn-sm'>
            <i class='glyphicon glyphicon-pencil'></i>
          </a>".html_safe
    end
    if can?(:read,i)
      read_button="<a href='#{client_group_path(i)}' role='button' class='btn btn-success btn-sm'>
            <i class='glyphicon glyphicon-eye-open'></i>
          </a>".html_safe
    end
    if can?(:destroy,i)
      delete_button=  link_to(i, method: :delete, data: { confirm: 'Wirklich löschen? ' }, class: 'btn btn-danger', role: 'button', title: 'Klasse löschen') do
        "<i class='glyphicon glyphicon-remove'></i>".html_safe
      end
    end
    "<div class='btn-group btn-group-nowrap btn-group-xs  pull-right'>
      #{read_button}
      #{update_button}
      #{delete_button}
    </div>".html_safe
  end

end