class EducationalCourse < ActiveRecord::Base

  has_and_belongs_to_many :institutions, class_name: '::Institution',
           inverse_of: :educational_courses

  has_many :educational_course_rules, class_name: '::EducationalCourseRule',
           foreign_key: :educational_course_id,
           inverse_of: :educational_course,
           dependent: :destroy
  accepts_nested_attributes_for :educational_course_rules, reject_if: :all_blank

  validates_presence_of :name, :valid_from


  def check_career(client)
     violated = []
     if client.career_items.where(change_type:  CareerItem::CHANGE_TYPE_CLIENT_GROUP, course_stage_names: nil).exists?
        # cannot check
       return violated
     end
     rules = EducationalCourseRule.all.index_by(&:course_stage_name)
     times = {}
     client.career_items.where(change_type:  CareerItem::CHANGE_TYPE_CLIENT_GROUP).order(start_at: :asc).each do |ci|
       ci.course_stage_names.each do |stage|
         times[stage] = 0 unless times.has_key? stage
         times[stage] += 1
       end
     end
     times.each do |stage,duration|
       rules[stage].client = client
       rules[stage].duration = duration
       if rules[stage].violated?
         violated << rules[stage]
       end
     end

  end


end
