module Portfolio
  module Conditions
    class SpecificResultMatcher < ItemMatcher

        attr_accessor :choices

        def initialize
          @choices = nil
        end

        def match?(portfolio_item)
          if portfolio_item.portfolio_step_result.nil?
            return false
          end
          @choices.include?(portfolio_item.portfolio_step_result.char)
        end

        def description
          results = []
          condition.portfolio_steps.each do |step|
            # actually, this portfolio matcher must not only include the choices, but also the step that should include the result.
            # TODO: extend this matcher appropriately, so there can be no two steps with a result with the same char, which is ambigous
            step.portfolio_step_results.each do |result|
              if @choices.include?(result.char)
                results << result.name
              end
            end
          end
          results.join(' <b>|</b><br/> ').html_safe
        end
      end
  end
end
