class SystemCareerItem < ActiveRecord::Base
  self.table_name = 'career_items'
  default_scope  { joins(:client).where("date_trunc('day',  clients.created_at) <= start_at").order(start_at: :desc,created_at: :desc) }


  #--- Associations
  belongs_to :client        # never NULL
  belongs_to :institution   # can be NULL
  belongs_to :client_group  # can be NULL
  belongs_to :teacher       # can be NULL


  validate on: :update do
    if effective_date_changed?
      if end_at.nil? && effective_date > Date.today
        errors.add(:effective_date,'Dies ist der jüngste Eintrag seiner Art. Das Datum des Inkrafttretens kann hier nur in der Vergangenheit gesetzt werden.')
      end
      if end_at.present? && effective_date > end_at
        errors.add(:effective_date,"Das Datum kann nicht nach dem Systemdatum (#{I18n::localize(end_at,format: :short)}) des nächsten Eintrags dieser Art gesetzt werden.")
      end
      _previous = CareerItem.where(client_id: client_id, change_type: change_type).where('end_at <= ?',start_at).order(end_at: :desc,created_at: :desc).first
      if _previous.present? && effective_date < _previous.start_at
        errors.add(:effective_date,"Das Datum kann nicht vor dem Systemdatum  (#{I18n::localize( _previous.start_at,format: :short)}) des letzten Eintrags dieser Art gesetzt werden.")
      end
    end
  end





end
