class User < ActiveRecord::Base
  belongs_to :identifiable, polymorphic: true
  include AuthorizationUserConcern

  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  # this overridden function seems to be unnecessary, but without it, no email is sent by devise.
  # addtionally, sending by the message queue does not work, the smtp configuration that is used seems to
  # be the default.
  # TODO: find out what is the problem and fix it.
  def send_devise_notification(notification, *args)
    message = devise_mailer.send(notification, self, *args)
    message.deliver_now
  end

  before_create do
    self.super_admin=true unless User.any?
  end

  def person
    @person = identifiable unless @person.present?
    return @person
  end

  def is_teacher?
    self.identifiable.is_a? Teacher
  end

  def is_guardian?
    self.identifiable.is_a? Guardian
  end

  def is_supporter?
    self.identifiable.is_a? Supporter
  end

  def is_client?
    self.identifiable.is_a? Client
  end

  def is_manager?
    self.identifiable.is_a? Manager
  end

end
