Rails.application.configure do
  # Settings specified here will take precedence over those in config/application.rb.

  # In the development environment your application's code is reloaded on
  # every request. This slows down response time but is perfect for development
  # since you don't have to restart the web server when you make code changes.
  config.cache_classes = false
  config.allow_concurrency=true # this is important for concurrent webservice calls, in production, it is default

  # Do not eager load code on boot.
  config.eager_load = false

  # Show full error reports and disable caching.
  config.consider_all_requests_local       = true
  config.action_controller.perform_caching = false

  config.action_mailer.delivery_method = (ENV['MAILER_DELIVERY_METHOD'] ? ENV['MAILER_DELIVERY_METHOD'].to_sym : :sendmail)
  config.action_mailer.raise_delivery_errors = true
  config.action_mailer.perform_deliveries = true
  config.action_mailer.default_url_options = { host: 'localhost', port: 3000  }
  config.mailer_sender = ENV['MAILER_FROM']
  config.action_mailer.default_options = {
      from: ENV['MAILER_FROM'],
      reply_to: ENV['MAILER_REPLY_TO']
  }
  config.action_mailer.smtp_settings = {
      address:              ENV['MAILER_SMTP_ADDRESS'],
      port:                 ENV['MAILER_SMTP_PORT'],
      domain:               ENV['MAILER_SMTP_DOMAIN'],
      user_name:            ENV['MAILER_SMTP_USER_NAME'],
      password:             ENV['MAILER_SMTP_PASSWORD'],
      authentication:       ENV['MAILER_SMTP_AUTHENTICATION'],
      enable_starttls_auto: ENV['MAILER_SMTP_ENABLE_STARTTLS_AUTO']
  }
  config.action_mailer.sendmail_settings = {
      location:             ENV['MAILER_SENDMAIL_LOCATION'],
      arguments:            ENV['MAILER_SENDMAIL_ARGUMENTS']
  }

  # Print deprecation notices to the Rails logger.
  config.active_support.deprecation = :log

  # Raise an error on page load if there are pending migrations.
  config.active_record.migration_error = :page_load

  # Debug mode disables concatenation and preprocessing of assets.
  # This option may cause significant delays in view rendering with a large
  # number of complex assets.
  config.assets.debug = false

  # Asset digests allow you to set far-future HTTP expiration dates on all assets,
  # yet still be able to expire them through the digest params.
  config.assets.digest = true

  # Adds additional error checking when serving assets at runtime.
  # Checks for improperly declared sprockets dependencies.
  # Raises helpful error messages.
  config.assets.raise_runtime_errors = false

  # Raises error for missing translations
  # config.action_view.raise_on_missing_translations = true

end
