desc "Task for recurring maintenance"

task 'vsb:cron', [:interval] => :environment do |task,args|
  if args[:interval].blank?
    puts "ERR=Please provide interval [ daily, weekly, monthly, annually]"
    exit 1
  end
  if args[:interval] == 'daily'
    Rake::Task["vsb:system_task_escalate"].invoke
    puts "OK=daily maintenance task done."
  end
  if args[:interval] == 'weekly'
    Rake::Task["vsb:cw_clean_tmp"].invoke
    Rake::Task["vsb:load_updated_semesters"].invoke
    Rake::Task["vsb:load_updated_educational_courses"].invoke
    puts "OK=weekly maintenance task done."
  end
  if args[:interval] == 'monthly'
    puts "OK=monthly maintenance task done."
  end
  if args[:interval] == 'annually'
    Rake::Task["tmp:cache:clear"].invoke
    puts "OK=annually maintenance task done."
  end
end

