require 'test_helper'
require 'pp'

class StringSimilarityTest < ActiveSupport::TestCase


  test 'typewriter_distance_to implementaion' do
    return true
    assert 'a'.typewriter_distance_to('a') == 0, '"a".typewriter_distance_to("a") must be 0'
    assert 'a'.typewriter_distance_to('4') == 0, '"a".typewriter_distance_to("4") must be 0 because 4 is not in list of usual characters'
    assert '1'.typewriter_distance_to('4') == 0, '"1".typewriter_distance_to("4") must be 0 because 1 and 4 are not in list of usual characters'
    assert_in_delta 1, 'a'.typewriter_distance_to('s'), 0.00001, '"a".typewriter_distance_to("s") must be 1'
    assert_in_delta 10, 'a'.typewriter_distance_to('ä'), 0.00001, '"a".typewriter_distance_to("ä") must be 10'
    assert_in_delta 1.11, 'a'.typewriter_distance_to('y'), 0.01, '"a".typewriter_distance_to("y") must be around 1.11'
    assert_in_delta 6.57, 'a'.typewriter_distance_to('m'), 0.01, '"a".typewriter_distance_to("m") must be around 6.57'
    assert_in_delta 9.79, 'a'.typewriter_distance_to('ü'), 0.01, '"a".typewriter_distance_to("ü") must be around 9.53'
    assert_in_delta 7.05, 'q'.typewriter_distance_to('m'), 0.01, '"q".typewriter_distance_to("m") must be around 6.89'
  end


  test 'false positives' do
    # the algorithm should not detect any of examples as duplicate
    to = []
    File.open(Rails.root + 'test/core_ext/duplicate_names_fp.txt', 'r') do |f|
      f.each_line do |t|
        if t.first != '#' && t.strip.length != 0
          a = t.split('->')
          a[1] = a[1].split(',')
          to += [a]
        end

      end
    end
    mat = 0;c = 0;
    mar = []
    to.each do |t|
      t[1].each do |k|
        c += 1
        if t[0].similar?(k)
          mat += 1
          mar << "#{t[0]}->#{k} "
        end
      end
    end
    assert( mat.to_f/c.to_f == 0, "must detect no examples that are not the same person. ERROR RATE: #{(mat.to_f/c.to_f).to_s} ERRORS: #{mar.join('|')}")
  end

  test 'false negatives' do
    # the algorithm should  detect all of examples as duplicate
    to = []
    File.open(Rails.root + 'test/core_ext/duplicate_names_fn.txt', 'r') do |f|
      f.each_line do |t|
        if t.first != '#' && t.strip.length != 0
          a = t.split('->')
          a[1] = a[1].split(',')
          to += [a]
        end
      end
    end

    mat = 0
    c=0
    mar = []
    to.each do |t|
      t[1].each do |k|
        c += 1
        if t[0].similar?(k)
          mat += 1
        else
          mar += [t[0],k]
        end
      end
    end
    assert( mat==c, "must detect all as the same person ERROR RATE: #{(mat.to_f/c.to_f).to_s} ERRORS: #{mar.join('|')}" )
  end

  #
  # test 'sample_data' do
  #   first_names = []
  #   last_names = []
  #   full_names = []
  #   File.open(Rails.root + 'test/core_ext/real_names.txt', 'r') do |f|
  #     f.each_line do |t|
  #         a = t.split(';')
  #         first_names << a.first.strip
  #         last_names << a.last.strip
  #         full_names << "#{ a.first.strip} #{a.last.strip}"
  #     end
  #   end
  #
  #
  #   match_first_name = "Phillip"
  #   match_last_name = "Herzberg"
  #
  #
  #   first_names.each do |name|
  #     if name.similar?(match_first_name)
  #       puts "Matched first_name: #{name} is like #{match_first_name}"
  #     end
  #   end
  #   last_names.each do |name|
  #     if name.similar?(match_last_name)
  #       puts "Matched last_name: #{name} is like #{match_last_name}"
  #     end
  #   end
  # end


  test 'misspellings' do
    return true
    to = []
    File.open(Rails.root + 'test/core_ext/misspellings.txt', 'r') do |f|
      f.each_line do |t|
        a = t.split('->')
        a[1] = a[1].split(',')
        to += [a]
      end
    end
    mat = 0;c = 0;
    to.each do |t|
      t[1].each do |k|
         c += 1
         if t[0].levenshtein_distance_to(k,true) <= 0.4
           mat += 1
         end
      end
    end
    assert_in_delta 0.95, (mat.to_f / c.to_f), 0.05, 'similarity must be around 0.95'
  end


end
