require 'test_helper'
require 'pp'
module PortfolioValidation
  module ItemValidation
    module Validators
      class AdvancementPlanTest < ActiveSupport::TestCase

        setup do
          @matcher = Portfolio::AdvancementPlanPresentValidator::Base.new
        end


        test "matches item with AdvancementPlan" do
          item = ::Portfolio::Item.new
          item.advancement_plans.build
          assert @matcher.match?(item)==true
        end

        test "matches no item without  AdvancementPlan" do
          item = ::Portfolio::Item.new
          assert @matcher.match?(item)==false
          assert @matcher.has_error == true
          assert @matcher.error_message.present?
          assert @matcher.error_proc.is_a? Proc
        end

      end
    end
  end
end