require 'test_helper'
require 'pp'
module PortfolioValidation
  module ItemValidation
    module Validators
      class DiagnosticTest < ActiveSupport::TestCase

        setup do
          @matcher = Portfolio::DiagnosticPresentValidator::Client.new
        end


        test "matches item with Diagnostic" do
          item = ::Portfolio::Item.new
          item.diagnostics.build
          assert @matcher.match?(item)==true
        end

        test "matches no item without  Diagnostic" do
          item = ::Portfolio::Item.new
          assert @matcher.match?(item)==false
          assert @matcher.has_error == true
          assert @matcher.error_message.present?
          assert @matcher.error_proc.is_a? Proc
        end

      end
    end
  end
end