require 'test_helper'
require 'pp'
module PortfolioValidation
  module ItemValidation
    module Validators
      class InvolvedPersonTest < ActiveSupport::TestCase

        setup do
          @matcher = Portfolio::InvolvementValidator::Client.new
          @matcher_teachers = Portfolio::InvolvementValidator::Client.new
          @matcher_teachers.types = ['teachers']
        end


        test "matches item with Any" do
          item = ::Portfolio::Item.new
          item.portfolio_item_involved_guardians.build
          assert @matcher.match?(item)==true
        end

        test "matches no item without Any" do
          item = ::Portfolio::Item.new
          assert @matcher.match?(item)==false
          assert @matcher.has_error == true
          assert @matcher.error_message.present?
          assert @matcher.error_proc.is_a? Proc
        end

        test "matches item with Teacher" do
          item = ::Portfolio::Item.new
          item.portfolio_item_involved_teachers.build
          assert @matcher_teachers.match?(item)==true
        end

        test "matches no item without Teacher" do
          item = ::Portfolio::Item.new
          item.portfolio_item_involved_guardians.build
          assert @matcher_teachers.match?(item)==false
          assert @matcher_teachers.has_error == true
          assert @matcher_teachers.error_message.present?
          assert @matcher_teachers.error_proc.is_a? Proc
        end

      end
    end
  end
end