require 'test_helper'
require 'pp'
module PortfolioValidation
  module ItemValidation
    module Validators
      class MeasurementTest < ActiveSupport::TestCase
        setup do
          @matcher = Portfolio::MeasurementPresentValidator::Base.new
        end


        test "matches item with Evaluation" do
          item = ::Portfolio::Item.new
          item.measurements.build
          assert @matcher.match?(item)==true
        end

        test "matches no item without Evaluation" do
          item = ::Portfolio::Item.new
          assert @matcher.match?(item)==false
          assert @matcher.has_error == true
          assert @matcher.error_message.present?
          assert @matcher.error_proc.is_a? Proc
        end
      end
    end
  end
end