require 'test_helper'
require 'pp'
module PortfolioValidation
  module ItemValidation
    module Validators
      class RequestManagementConferenceTest < ActiveSupport::TestCase
        setup do
          @matcher = Portfolio::RequestManagementConferenceValidator::Base.new
        end


        test "matches item with management_conference" do
          item = ::Portfolio::Item.new
          item.management_conference=true
          assert @matcher.match?(item)==true
        end

        test "matches no item without management_conference" do
          item = ::Portfolio::Item.new
          item.management_conference=false
          assert @matcher.match?(item)==false
          assert @matcher.has_error == true
          assert @matcher.error_message.present?
          assert @matcher.error_proc.is_a? Proc
        end
      end
    end
  end
end