require 'test_helper'
require 'pp'
module PortfolioValidation
  module ItemValidation
    module Validators
      class RequestParentTeacherConferenceTest < ActiveSupport::TestCase
        setup do
          @matcher = Portfolio::RequestParentTeacherConferenceValidator::Client.new
        end

        test "matches item with parent_teacher_conference" do
          item = ::Portfolio::Item.new
          item.parent_teacher_conference=true
          assert @matcher.match?(item)==true
        end

        test "matches no item without parent_teacher_conference" do
          item = ::Portfolio::Item.new
          item.parent_teacher_conference=false
          assert @matcher.match?(item)==false
          assert @matcher.has_error == true
          assert @matcher.error_message.present?
          assert @matcher.error_proc.is_a? Proc
        end
      end
    end
  end
end