require 'test_helper'
require 'pp'
module PortfolioValidation
  module ItemValidation
    module Validators
      class TargetAgreementsTest < ActiveSupport::TestCase
        setup do
          @matcher = Portfolio::TargetAgreementsPresentValidator.new
        end


        test "matches item with target_agreements" do
          item = ::Portfolio::Item.new
          item.target_agreements.build
          assert @matcher.match?(item)==true
        end

        test "matches no item without target_agreements" do
          item = ::Portfolio::Item.new
          assert @matcher.match?(item)==false
          assert @matcher.has_error == true
          assert @matcher.error_message.present?
          assert @matcher.error_proc.is_a? Proc
        end

      end
    end
  end
end